/*******************************************************************************
* File Name: IO_COMP.h  
* Version 2.20
*
* Description:
*  This file contains the Alias definitions for Per-Pin APIs in cypins.h. 
*  Information on using these APIs can be found in the System Reference Guide.
*
* Note:
*
********************************************************************************
* Copyright 2008-2015, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_IO_COMP_ALIASES_H) /* Pins IO_COMP_ALIASES_H */
#define CY_PINS_IO_COMP_ALIASES_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"


/***************************************
*              Constants        
***************************************/
#define IO_COMP_0			(IO_COMP__0__PC)
#define IO_COMP_0_PS		(IO_COMP__0__PS)
#define IO_COMP_0_PC		(IO_COMP__0__PC)
#define IO_COMP_0_DR		(IO_COMP__0__DR)
#define IO_COMP_0_SHIFT	(IO_COMP__0__SHIFT)
#define IO_COMP_0_INTR	((uint16)((uint16)0x0003u << (IO_COMP__0__SHIFT*2u)))

#define IO_COMP_INTR_ALL	 ((uint16)(IO_COMP_0_INTR))


#endif /* End Pins IO_COMP_ALIASES_H */


/* [] END OF FILE */
