/*******************************************************************************
* File Name: PWM_BUZZ_PM.c
* Version 2.10
*
* Description:
*  This file contains the setup, control, and status commands to support
*  the component operations in the low power mode.
*
* Note:
*  None
*
********************************************************************************
* Copyright 2013-2015, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions,
* disclaimers, and limitations in the end user license agreement accompanying
* the software package with which this file was provided.
*******************************************************************************/

#include "PWM_BUZZ.h"

static PWM_BUZZ_BACKUP_STRUCT PWM_BUZZ_backup;


/*******************************************************************************
* Function Name: PWM_BUZZ_SaveConfig
********************************************************************************
*
* Summary:
*  All configuration registers are retention. Nothing to save here.
*
* Parameters:
*  None
*
* Return:
*  None
*
*******************************************************************************/
void PWM_BUZZ_SaveConfig(void)
{

}


/*******************************************************************************
* Function Name: PWM_BUZZ_Sleep
********************************************************************************
*
* Summary:
*  Stops the component operation and saves the user configuration.
*
* Parameters:
*  None
*
* Return:
*  None
*
*******************************************************************************/
void PWM_BUZZ_Sleep(void)
{
    if(0u != (PWM_BUZZ_BLOCK_CONTROL_REG & PWM_BUZZ_MASK))
    {
        PWM_BUZZ_backup.enableState = 1u;
    }
    else
    {
        PWM_BUZZ_backup.enableState = 0u;
    }

    PWM_BUZZ_Stop();
    PWM_BUZZ_SaveConfig();
}


/*******************************************************************************
* Function Name: PWM_BUZZ_RestoreConfig
********************************************************************************
*
* Summary:
*  All configuration registers are retention. Nothing to restore here.
*
* Parameters:
*  None
*
* Return:
*  None
*
*******************************************************************************/
void PWM_BUZZ_RestoreConfig(void)
{

}


/*******************************************************************************
* Function Name: PWM_BUZZ_Wakeup
********************************************************************************
*
* Summary:
*  Restores the user configuration and restores the enable state.
*
* Parameters:
*  None
*
* Return:
*  None
*
*******************************************************************************/
void PWM_BUZZ_Wakeup(void)
{
    PWM_BUZZ_RestoreConfig();

    if(0u != PWM_BUZZ_backup.enableState)
    {
        PWM_BUZZ_Enable();
    }
}


/* [] END OF FILE */
