/***********************************************************************/
/*                                                                     */
/*  FILE        :main.h                                                */
/*  DATE        :Fri, Jul 29, 2011                                     */
/*  DESCRIPTION :define scalar types.                                  */
/*  author:Song Bingzhao                                               */
/*                                                                     */
/*                                                                     */
/***********************************************************************/


#ifndef MAIN_H
#define MAIN_H

#include "Typedefine.h"
#include "Global.h"
#include "Psoc4_dgc.h"

extern void InitMCU(void);
extern void ReWriteReg(void);
extern void HalfSecTimeBase(void);
extern void I2C_Read_Page(void);
extern void WriteE2(void);
extern void AdSample(void);
extern void JudgeAdErr(void);
extern void KeyFunction(void);
extern void JudgeRoomTempRange(void);
extern void FrequencyConvert(void);
extern void FrzFanCtrl(void);
extern void CoolFanCtrl(void);
extern void ClrHourTime(hour_def *Pointer);
extern void ShortenTime(void);
extern void MusicBeep(void);
extern void SetSound(SoundName_em SoundAddr);
extern void NetFunction(void);
extern void BarHeaterCtrl(void);
extern void RefDispRule(void);
extern void FrzDispRule(void);
extern void RefDamperCtrlOut(void);
extern void VarDamperCtrlOut(void);
extern void FrzFanCtrlOut(void);
extern void CoolFanCtrlOut(void);

void PowerOnWait5SCtrl(void);
void DealSendData(void);
void DealRecData(void);
void NetSettingCheck(void);
void ResetE2(void);
void InitUserRegister(void);
void WriteE2Ctrl(void);
void CheckRefDoor(void);
void CheckFrzDoor(void);
void CheckBarDoor(void);
void MainCtrlCourse(void);
void TestCtrl(void);
void SaveCompressorOnTime(void);
void GetMachineParameter(void);
void PowerOnCompDelay(void);
void SuperFrzCtrl(void);
void SuperCoolCtrl(void);
void FuzzyCtrl(void);
void JudgeFrzState(void);
void JudgeRefState(void);
void JudgeRefStateAT15CTo35C(void);
void JudgeVarState(void);
void DefrostFunction(void);
void CountOpenDoorTime(void);
void JudgeEnterDefrost(void);
void JudgeSuperFrzDef(void);
void EnterPreCooling(void);
void EnterDefrost(void);
void RefForceState(void);
void FrzForceState(void);
void CompressorCtrl(void);
void CompressorCtrlAT15CTo35C(void);
void StartCompressor(void);
void StopCompressor(void);
void RefDamperCtrl(void);
void OpenRefDamper(void);
void CloseRefDamper(void);
void VarDamperCtrl(void);
void Open90VarDamper(void);
void Open20VarDamper(void);
void CloseVarDamper(void);
void DamperHeaterCtrl(void);
void DefrostHeaterCtrl(void);
void FreshLedCtrl(void);
void FrzLampCtrl(void);
void RefLampCtrl(void);
void LoadOutput(void);
void LoadOutputAtOnce(void);
void AlarmCtrl(void);
void JudgeDoorAlarm(void);
void AlarmAct(void);
void JudgeSystemErr(void);
void JudgeCycleErr(void);
void JudgeRefDoorErr(void);
void JudgeFrzDoorErr(void);
void JudgeBarDoorErr(void);
void JudgeMainRecErr(void);
void JudgeEuropeSuperFrzDef(void);


extern uchar u8_HalfSec;
extern uchar u8_Second;
extern uchar u8_Min;
extern RoomTemp_em em_RoomTemp;
extern uchar u8_AfterDefFrzDispTimer;
extern uchar u8_PartCheckNum;
extern uchar u8_FrzFanDlyOnTimer;

extern uint u16_FrzTemp;
extern uint u16_RefTemp;
extern uint u16_RoomTemp;
extern uint u16_VarTemp;
extern uint u16_DefTemp;
extern uint u16_RunTimeMin;
extern uchar u8_VarDamperOpenTimer;
extern uchar u8_Door180mintimer;
extern uint u16_RefOnTemplast;
extern uint u16_RefOffTemplast;

extern uint  u16_PwmStepTimer;
extern uchar u8_FrzFanNeedSpeed;
extern uchar u8_CoolFanNeedSpeed;

#define T_4HOUR                     4u
#define T_7HOUR                     7u
#define T_10HOUR                    10u
#define T_12HOUR                    12u
#define T_14HOUR                    14u
#define T_20HOUR                    20u
#define T_48HOUR                    48u
#define T_73HOUR                    73u
#define T_60MIN                     60u
#define T_40S                       40u
#define T_80S                       80u
#define T_180S                      180u

#define CON_RefToolCool              25

#define CON_OnAd                      0
#define CON_OffAd                     1
#define CON_OnTemp                    0
#define CON_OffTemp                   1
#define CON_RefOnTime                 0
#define CON_RefOffTime                1
#define CON_VarOnTime                 0
#define CON_VarOffTime                1
#define CON_FrzOnTime                 0
#define CON_FrzOffTime                1

#define CON_MaxPreCoolingTime         30 //min
#define CON_ErrDefrostTime            30   //min
#define CON_MaxDefrostTime            70    //min
#define CON_MinDefrostTime            10 //second
#define CON_AfterStopTime             7  //min
#define CON_AfterCompTime             8  //min
#define CON_AfterFanTime              10  //min
#define CON_QuitDefrostTemp           450 //7 C
#define CON_QuitDefrostTemp1          510 //13C
#define CON_SuperFrzTime              50 //hour
#define CON_EuropeSuperFrzTime        50 //hour
#define CON_SuperCoolTime             360 //min
#define CON_AfterDefSuperCoolTime     180 //min
#define CON_HalfSuperCoolTime         (CON_SuperCoolTime/2) //min
#define CON_CompDlyTime               7  //min
#define CON_FuzzyRefSet               4 //4degree
#define CON_FuzzyFrzSet               6 //-18degree
#define CON_HolidayRefOnTemp          560 //18degree
#define CON_HolidayRefOffTemp         520 //14degree
#define CON_SuperFrzOnTemp            120 //-26degree
#define CON_SuperFrzOffTemp           100 //-28degree
#define CON_DamperClose               0


#define IO_RefDoor                    P45_IN //PDR2_P22 
#define IO_FrzDoor                    P62_IN//PDR3_P32 
#define IO_BarDoor                    P44_IN//PDR2_P21 
//#define IO_FrzLamp                    PDR3_P37 
#define IO_FrzLampON                  P17_0
#define IO_FrzLampOFF                 P17_1

//#define IO_RefLampUp                  PDR2_P23 
#define IO_RefLampUpON                P51_0 
#define IO_RefLampUpOFF               P51_1 


//#define IO_TabtLamp                   PDR6_P64 
#define IO_TabtLampON                 P13_0
#define IO_TabtLampOFF                P13_1
//#define IO_RefLampDown                PDR8_P81 
//#define IO_BarHeater                  PDR0_P02 


//#define IO_COMP                       PDR0_P00 
#define IO_COMPON                     P56_1
#define IO_COMPOFF                    P56_0
//#define IO_DEF_HEATER                 PDR0_P01 
#define IO_DEF_HEATERON               P57_1   
#define IO_DEF_HEATEROFF              P57_0

//#define IO_REFDAMPER_HEATER           PDR0_P03 
#define IO_REFDAMPER_HEATERON         P71_1
#define IO_REFDAMPER_HEATEROFF        P71_0

#endif
