
#include "Music.h"
#include "Timer0.h"
//#pragma DATA_SEG DEFAULT
uint u16_SoundTimer;
uchar u8_SoundStage;
uchar u8_cnt;
uint Watch0;
uint Watch1;
uint FreqRegTest;
const uint  *p_SoundAddress;
/**********************************************
**********************************************/

/**********************************************
**********************************************/

/**********************************************
**********************************************/


const unsigned short int ARY_Null[1]=
{					// num=0ʱֹͣ
  0
};

const unsigned short int ARY_Start[13]=
{					// num=0ʱֹͣ
  //frequency,on time,off time
  250000/1960,150,300,		//
	250000/2100,150,300,
	250000/2304,150,300,
  250000/2702,200,800,
	0
};


const unsigned short int ARY_Raise[10]=
{					// num=0ʱֹͣ
    250000/1667,40,60,  //raise
	250000/2000,40,60,
	250000/2500,60,100,
	0
};
	
const unsigned short int ARY_Drop[10]=
{					// num=0ʱֹͣ
  250000/2500,40,60,  //turn down
	250000/2000,40,60,
	250000/1667,60,100, 
	0
};

const unsigned short int ARY_FunctionOn[13]=
{					// num=0ʱֹͣ
  250000/1760,25,100,		//
	250000/1860,50,300,
	250000/1975,25,100,		//
	250000/2350,25,400,
	0
};

const unsigned short int ARY_FunctionOff[13]=
{					// num=0ʱֹͣ
  250000/2350,25,100,		//
	250000/1975,50,300,
	250000/1860,25,100,		//
	250000/1760,25,400,
  0	
};

const unsigned short int ARY_Alarm[19]=
{					// num=0ʱֹͣ
  250000/2630,60,250,  //ding ding dong
	250000/2630,60,250, 
	250000/2210,130,1000,
	250000/2630,60,250,  //ding ding dong
	250000/2630,60,250, 
	250000/2210,130,500,
	0
};

const unsigned short int ARY_DoorAlarm[10]=
{					// num=0ʱֹͣ
  250000/2000,500,800,
  250000/2000,500,800,
  250000/2000,600,1400,
	0
};

const unsigned short int ARY_Invalid[7]=
{					// num=0ʱֹͣ
  250000/1970,20,50,  //
	250000/2100,50,200,
	0
};


/******************************************/

void SetVolumState(unsigned char state)
{
	if(state == 0)							//20140804
	{
		//IO_BUZZ_EN = 0;
      //  IO_BUZZ_EN_LOW;
       //PWM_BUZZ_Stop();
	}
	else
	{
		//IO_BUZZ_EN = 1;
        IO_BUZZ_EN_HIGH; 
         // PWM_BUZZ_Start();
	}
}

void StopMusicBeep(void)
{
    //PCNTH1_PGMS=1;		//disable PPG output 
    PWM_BUZZ_WriteCompare(0);
    ///PWM_BUZZ_Stop();


}


/******************************************
Routine Name: StartSoundTone
Function: 趨Ƶʣ
******************************************/
void StartSoundTone(uint FreqRegValue)    
{	//PCSR1 = FreqRegValue;
	//PDUT1 = (FreqRegValue / 2);	//PDUTHn/PDUTLn : 16-bit PPG Duty Setting Buffer Register

//    PWM_BUZZ_Start();
//    PWM_BUZZ_Start();
//    PWM_BUZZ_Start();
    PWM_BUZZ_WritePeriod(FreqRegValue);
    PWM_BUZZ_WriteCompare(FreqRegValue/2);
 
    Watch0 = PWM_BUZZ_PERIOD_REG;
    Watch0 = PWM_BUZZ_PERIOD_REG;
	//PCNTH1_PGMS=0;		//enable PPG output 
}

//>>>>>>>>>>>>>>>ϳҪݲͬCPUĶ<<<<<<<<<<<

/************************************
Routine Name:SetSound
Function: 趨
Description: Value=
VALUE_NULL,VALUE_SUBON,VALUE_SUBOFF,VALUE_VCHANGE,VALUE_HCHANGE,VALUE_INVALIDKEY,VALUE_ALERT

************************************/
void SetSound(SoundName_em SoundAddr)
{
	u8_SoundStage=0xff;		// ֹͣڽе
	switch (SoundAddr)
	{
		case NULL_TONE:
		{
			p_SoundAddress = ARY_Null;	
		}break;	
		case START_TONE:
		{
			p_SoundAddress = ARY_Start;	
		}break;
		case RAISE_TONE:
		{
			p_SoundAddress = ARY_Raise;	
		}break;
		case DROP_TONE:
		{
			p_SoundAddress = ARY_Drop;	
		}break;
		case FUNCTION_ON_TONE:
		{
			p_SoundAddress = ARY_FunctionOn;	
		}break;
		case FUNCTION_OFF_TONE:
		{
			p_SoundAddress = ARY_FunctionOff;	
		}break;
		case ALARM_TONE:
		{
			p_SoundAddress = ARY_Alarm;	
		}break;
		case DOOR_ALARM_TONE:
		{
			p_SoundAddress = ARY_DoorAlarm;	
		}break;
		case INVALID_TONE:
		{
			p_SoundAddress = ARY_Invalid;	
		}break;
		default:break;
	}
}


/***************************************************
Routine Name:MusicBeep
Function; 
Description:
			SoundTimer: ʱ䳤ȼ5msΪһλ
			*SoundAddress : ǰ
			 	VALUE_SUBON,VALUE_SUBOFF,...
			 	ֹͣʱSoundAddress=DDr_NULL
			SoundStage: ǰȣΪʱon,żʱoff
						Ϊ0ffʱ
call: 
***************************************************/
void MusicBeep(void)
{
	if(p_SoundAddress==ARY_Null)
	{
		StopMusicBeep();
		SetVolumState(0);
		u8_SoundStage=0xff;
	}
	else
	{
		if(u8_SoundStage==0xff) // ״ν
		{ 
			u8_SoundStage=0;
			u16_SoundTimer=0;
            FreqRegTest =p_SoundAddress[3*(u8_SoundStage>>1)];
            StartSoundTone(FreqRegTest);
			//StartSoundTone(p_SoundAddress[3*(u8_SoundStage>>1)]);	// Ƶʣ
            Watch1 = PWM_BUZZ_PERIOD_REG;
            Watch1 = PWM_BUZZ_PERIOD_REG;
		}
		if(u8_SoundStage&0x01)
		{												// ׶
			SetVolumState(0);
			if(u16_SoundTimer>=p_SoundAddress[3*(u8_SoundStage>>1)+2])
			{		 									// 
				  Watch1 = PWM_BUZZ_PERIOD_REG;
                  Watch1 = PWM_BUZZ_PERIOD_REG;
////                  UART_TEST_SpiUartWriteTxData( Watch1);
////                  UART_TEST_SpiUartWriteTxData(u16_SoundTimer>>8);
////                  UART_TEST_SpiUartWriteTxData(u16_SoundTimer);
                UART_TEST_SpiUartWriteTxData(PWM_BUZZ_BLOCK_CONTROL_REG);
                UART_TEST_SpiUartWriteTxData(PWM_BUZZ_BLOCK_CONTROL_REG>>8);
                UART_TEST_SpiUartWriteTxData(PWM_BUZZ_BLOCK_CONTROL_REG>>16);
                UART_TEST_SpiUartWriteTxData(PWM_BUZZ_BLOCK_CONTROL_REG>>24);
//                 if(u8_SoundStage==1)
//                {
//                  Watch1 = PWM_BUZZ_PERIOD_REG;
//                  Watch1 = PWM_BUZZ_PERIOD_REG;
//                  UART_TEST_SpiUartWriteTxData( Watch1);
//                  UART_TEST_SpiUartWriteTxData(u16_SoundTimer>>8);
//                  UART_TEST_SpiUartWriteTxData(u16_SoundTimer);
//
//                }
//                 if(u8_SoundStage==3)
//                {
//                  Watch1 = PWM_BUZZ_PERIOD_REG;
//                  Watch1 = PWM_BUZZ_PERIOD_REG;
//                  UART_TEST_SpiUartWriteTxData( Watch1);
//                  UART_TEST_SpiUartWriteTxData(u16_SoundTimer>>8);
//                  UART_TEST_SpiUartWriteTxData(u16_SoundTimer);
//
//                }
                u8_SoundStage++;
				u16_SoundTimer=0;
				if(p_SoundAddress[3*(u8_SoundStage>>1)]==0) 
				{
					p_SoundAddress=ARY_Null;						// ֹͣ
                    UART_TEST_SpiUartWriteTxData(0xFF);
				}
				else
				{
					SetVolumState(1);								// һ
					StartSoundTone(p_SoundAddress[3*(u8_SoundStage>>1)]);	
                    CyDelay(10);
				}
                
			}
		}
		else
		{  
			SetVolumState(1);
			if(u16_SoundTimer>=p_SoundAddress[3*(u8_SoundStage>>1)+1])
			{
                  Watch1 = PWM_BUZZ_PERIOD_REG;
                  Watch1 = PWM_BUZZ_PERIOD_REG;
                UART_TEST_SpiUartWriteTxData(PWM_BUZZ_BLOCK_CONTROL_REG);
                UART_TEST_SpiUartWriteTxData(PWM_BUZZ_BLOCK_CONTROL_REG>>8);
                UART_TEST_SpiUartWriteTxData(PWM_BUZZ_BLOCK_CONTROL_REG>>16);
                UART_TEST_SpiUartWriteTxData(PWM_BUZZ_BLOCK_CONTROL_REG>>24);
////                  UART_TEST_SpiUartWriteTxData( Watch1);
////                  UART_TEST_SpiUartWriteTxData(u16_SoundTimer>>8);
////                  UART_TEST_SpiUartWriteTxData(u16_SoundTimer);
//                if(u8_SoundStage==4)
//                {
//                  Watch1 = PWM_BUZZ_PERIOD_REG;
//                  Watch1 = PWM_BUZZ_PERIOD_REG;
//                  UART_TEST_SpiUartWriteTxData( Watch1);
//                  UART_TEST_SpiUartWriteTxData(u16_SoundTimer>>8);
//                  UART_TEST_SpiUartWriteTxData(u16_SoundTimer);
//                   // UART_TEST_SpiUartWriteTxData( Watch1);
//                }
//                if(u8_SoundStage==2)
//                {
//                  Watch1 = PWM_BUZZ_PERIOD_REG;
//                  Watch1 = PWM_BUZZ_PERIOD_REG;
//                  UART_TEST_SpiUartWriteTxData( Watch1);
//                  UART_TEST_SpiUartWriteTxData(u16_SoundTimer>>8);
//                  UART_TEST_SpiUartWriteTxData(u16_SoundTimer);
//                   // UART_TEST_SpiUartWriteTxData( Watch1);
//                }
//                if(u8_SoundStage==0)
//                {
//                  Watch1 = PWM_BUZZ_PERIOD_REG;
//                  Watch1 = PWM_BUZZ_PERIOD_REG;
//                  UART_TEST_SpiUartWriteTxData( Watch1);
//                  UART_TEST_SpiUartWriteTxData(u16_SoundTimer>>8);
//                  UART_TEST_SpiUartWriteTxData(u16_SoundTimer);
//                  
//                }
				u8_SoundStage++;
                
				u16_SoundTimer=0;
				SetVolumState(0);										// ʼ
			}
		}
	}
}