/***********************************************************************/
/*                                                                     */
/*  FILE        :Typedefine.h                                              */
/*  DATE        :Thu, Jul 09, 2009                                     */
/*  DESCRIPTION :define scalar types.                                  */
/*  CPU GROUP   :2A                                                    */
/*                                                                     */
/*  This file is generated by Renesas Project Generator (Ver.4.12).    */
/*                                                                     */
/***********************************************************************/

#ifndef TYPEDEFINE_H
#define TYPEDEFINE_H

typedef unsigned char uchar;	/* unsigned 8 bit type definition */
typedef unsigned short int  uint;	  /* unsigned 16 bit type definition */
typedef unsigned long ulong;	/* unsigned 32 bit type definition */

typedef unsigned char u8;	  /* unsigned 8 bit type definition */
typedef signed char   s8;		/* signed 8 bit type definition */
typedef unsigned short int  u16;	/* unsigned 16 bit type definition */
typedef signed   short int    s16;	/* signed 16 bit type definition */
typedef unsigned long u32;	/* unsigned 32 bit type definition */
typedef signed long   s32;	/* signed 32 bit type definition */

typedef union 
{
   	uchar Byte;
  	struct {
	uchar BIT0        :1;                                       /* Bit 0 */
	uchar BIT1        :1;                                       /* Bit 1 */
	uchar BIT2        :1;                                       /* Bit 2 */
	uchar BIT3        :1;                                       /* Bit 3 */
	uchar BIT4        :1;                                       /* Bit 4 */
	uchar BIT5        :1;                                       /* Bit 5 */
	uchar BIT6        :1;                                       /* Bit 6 */
	uchar BIT7        :1;                                       /* Bit 7 */
  } Bits;
} BitType;
typedef union{
	signed int Word;
	struct{
		unsigned int ByteH:8;
		unsigned int ByteL:8;
		}WordHL;
	}MyWord;

typedef union {
  unsigned	char Byte;
  struct {
	unsigned	char             :1;  
    unsigned	char             :1; 
    unsigned	char VARDAMPER   :2;               // Var damper state  
    unsigned	char CFAN        :2;               // cooling fan speed     
	unsigned	char FFAN        :2;               // frz fan speed 
    
  } Bits;
} MyflagFanSpeed;

typedef struct {
uchar RefSet;
uchar FrzSet;
uchar VarSet;
BitType FlagState1;
BitType FlagState2;
BitType FlagState3;
uchar SavedCompTime;
uchar SignAA;
} MachineParameter_st;

typedef struct {
uint  SumAd;
uint MaxAd;
uint MinAd;
} AdSample_st;

typedef enum
{
  NULL_TONE,START_TONE,RAISE_TONE,DROP_TONE,FUNCTION_ON_TONE,FUNCTION_OFF_TONE,
  ALARM_TONE,DOOR_ALARM_TONE,INVALID_TONE
} SoundName_em;

typedef struct																/*小时,分钟,秒结构*/
{
	unsigned char	 hour;
	unsigned char	 minute;
	unsigned char	 second;
}hour_def;

typedef enum
{
  NORMAL_MODE,PRE_COOLING_MODE,DEFROST_MODE,AFTER_STOP_MODE,
  AFTER_COMP_MODE,AFTER_FAN_MODE
} DefrostMode_em;

typedef enum
{
  BELOW8,BELOW12,BELOW20,BELOW28,BELOW35,BELOW40,UP40
} RoomTemp_em;

typedef enum
{
  NORMAL,RUN_TIME,FRZ_TEMP,DEF_TEMP,REF1_TEMP,REF2_TEMP,ROOM_TEMP,VAR_TEMP,
  ICE_TEMP, DISP_VER,MAIN_VER,SLAVE_VER
} SpecialMode_em;

typedef enum
{
  DAMPER_STATE_A,DAMPER_STATE_B,DAMPER_STATE_C,DAMPER_STATE_D
} DamperState_em;
#endif
