/*******************************************************************************
* File Name: IN_500us.h
* Version 1.70
*
*  Description:
*   Provides the function definitions for the Interrupt Controller.
*
*
********************************************************************************
* Copyright 2008-2015, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/
#if !defined(CY_ISR_IN_500us_H)
#define CY_ISR_IN_500us_H


#include <cytypes.h>
#include <cyfitter.h>

/* Interrupt Controller API. */
void IN_500us_Start(void);
void IN_500us_StartEx(cyisraddress address);
void IN_500us_Stop(void);

CY_ISR_PROTO(IN_500us_Interrupt);

void IN_500us_SetVector(cyisraddress address);
cyisraddress IN_500us_GetVector(void);

void IN_500us_SetPriority(uint8 priority);
uint8 IN_500us_GetPriority(void);

void IN_500us_Enable(void);
uint8 IN_500us_GetState(void);
void IN_500us_Disable(void);

void IN_500us_SetPending(void);
void IN_500us_ClearPending(void);


/* Interrupt Controller Constants */

/* Address of the INTC.VECT[x] register that contains the Address of the IN_500us ISR. */
#define IN_500us_INTC_VECTOR            ((reg32 *) IN_500us__INTC_VECT)

/* Address of the IN_500us ISR priority. */
#define IN_500us_INTC_PRIOR             ((reg32 *) IN_500us__INTC_PRIOR_REG)

/* Priority of the IN_500us interrupt. */
#define IN_500us_INTC_PRIOR_NUMBER      IN_500us__INTC_PRIOR_NUM

/* Address of the INTC.SET_EN[x] byte to bit enable IN_500us interrupt. */
#define IN_500us_INTC_SET_EN            ((reg32 *) IN_500us__INTC_SET_EN_REG)

/* Address of the INTC.CLR_EN[x] register to bit clear the IN_500us interrupt. */
#define IN_500us_INTC_CLR_EN            ((reg32 *) IN_500us__INTC_CLR_EN_REG)

/* Address of the INTC.SET_PD[x] register to set the IN_500us interrupt state to pending. */
#define IN_500us_INTC_SET_PD            ((reg32 *) IN_500us__INTC_SET_PD_REG)

/* Address of the INTC.CLR_PD[x] register to clear the IN_500us interrupt. */
#define IN_500us_INTC_CLR_PD            ((reg32 *) IN_500us__INTC_CLR_PD_REG)



#endif /* CY_ISR_IN_500us_H */


/* [] END OF FILE */
